//
//  glpng̎gpTv
//
//  gcc sample.c -I/usr/include/opengl -lglpng -lglut32 -lglu32 -lopengl32
//
#include <GL/glut.h>
#include <GL/glpng.h>
#include <stdio.h>

void Display(void);
void Reshape(int, int);
void PutSprite(int, int, int, pngInfo *);

//  PNG摜ǂݍނ߂̕ϐ
GLuint img1;
pngInfo info1;


//
//  Program start
//
int main(int argc, char **argv)
{
    //  ʓIȏ
    glutInit(&argc, argv);
    glutInitWindowSize(640, 480);
    glutCreateWindow("Test for glpng");
    glutInitDisplayMode(GLUT_RGBA | GLUT_ALPHA);
    glClearColor(0.0, 0.0, 1.0, 1.0);

    //  eNX`̃At@`lLɂݒ
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

    //  PNG摜̓ǂݍ
    img1 = pngBind("72220034.png", PNG_NOMIPMAP, PNG_ALPHA, &info1,
                   GL_CLAMP, GL_NEAREST, GL_NEAREST);

    //  R[obN֐̓o^
    glutDisplayFunc(Display);
    glutReshapeFunc(Reshape);

    //  Cxg[v˓
    glutMainLoop();

    return(0);
}


//
//  EBhẼTCYύXƂɍWnĐݒ肷֐
//
void Reshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluOrtho2D(0, w, 0, h);
    glScaled(1, -1, 1);
    glTranslated(0, -h, 0);
}


//
//  EBhE̕\eXV
//
void Display(void)
{
    int w, h;
    int x, y;

    glClear(GL_COLOR_BUFFER_BIT);

    w = info1.Width;   //  eNX`̕ƍ擾
    h = info1.Height;
    x = 0;
    y = 0;

    glPushMatrix();

    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, img1);

    glBegin(GL_QUADS);  //  w, h̎lp`

    glTexCoord2i(0, 0); 
    glVertex2i(x, y);

    glTexCoord2i(0, 1);
    glVertex2i(x, y+h);

    glTexCoord2i(1, 1);
    glVertex2i(x+w, y+h);

    glTexCoord2i(1, 0);
    glVertex2i(x+w, y);

    glEnd();

    glPopMatrix();

    glFlush();
}
